// Create a quarter torus.

/* Define the properties of the torus in the calling file */
/*
#declare TorusMajorRadius = 1
#declare TorusMinorRadius = 0.5
*/

/* Error checking */
#ifndef (TorusMajorRadius)
#error "TorusMajorRadius not defined\n"
#end
#ifndef (TorusMinorRadius)
#error "TorusMinorRadius not defined\n"
#end

#declare QuarterTorus = intersection {
   torus {
      TorusMajorRadius
      TorusMinorRadius
   }
   box {
      <0, -TorusMinorRadius, 0>
      <TorusMajorRadius + TorusMinorRadius, TorusMinorRadius, TorusMajorRadius + TorusMinorRadius>
      scale 1.01
   }
   rotate -90 * x
}
